program TestDndEdit;
{$IFDEF VER70}
uses Objects, OWindows, OMemory, ODialogs, WinProcs, WinTypes, Strings, DnDEdit;
{$ELSE}
uses WObjects, WinProcs, WinTypes, Strings, DnDEdit;
{$ENDIF}
type
    TTestDndEdit = object(TApplication)
        TestEdit    : PDndEdit;
        procedure InitMainWindow; virtual;
    end;

var    App : TTestDndEdit;


procedure TTestDndEdit.InitMainWindow;
var
    TestString
        : String;
    Buffer : array[0..3024] of char;
    i,j, k : integer;
begin
    MainWindow := New(PWindow, Init(nil, 'DndEdit'));

    StrPCopy(Buffer, '');

    for i := 1 to 50 do
        begin
        TestString := '';
        if (i mod 5) = 0 then
            k    := 22
        else
            k    := 5;
        for j := 1 to k do
            begin
            TestString := TestString + Chr(Ord(' ')+i);
            end;
        TestString := TestString + Chr(13) + Chr(10) + #0;
        StrCat(Buffer, @TestString[1]);
        end;

{   TestEdit  := New(PEdit, Init(MainWindow, 98,
        @TestString,
        20, 20, 115, 90, 200, TRUE));}
{    StrPCopy(Buffer, TestString);}

    TestEdit  := New(PDndEdit, Init(MainWindow, 98,
        @Buffer, 20, 20, 200, 200, 0));


end;

var
    Rect : TRect;

begin
    App.Init('Test Numeric Edit');
    SetWindowPos(App.MainWindow^.HWindow, 0, 100, 100, 300, 300, 0);
    SetFocus(App.TestEdit^.HWindow);
    Rect.left := 10;
    Rect.top  := 10;
    Rect.bottom := 50;
    Rect.right := 50;
{    SendMessage(App.TestEdit^.HWindow, EM_SETRECT, 0, longint(@Rect));}

    App.Run;
    App.Done;
end.
