/*****************************************************/
/* dosname.h                                         */
/* -- Interface to DosName VxD.                      */
/*****************************************************/

/*****************************************************/
/* Types.                                            */
/*****************************************************/
/* Prototype for Window's callback function.
typedef DWORD (CALLBACK * LPFN_VXD)(void);

/*****************************************************/
/* Constants.                                        */
/*****************************************************/
/* VxD ID from Microsoft. */
#define wDosNameDeviceId    0x297b

/* Current version of VxD. */
#define wDosNameVersion     0x0101

/* Return VxD version number. */
#define apiGetVersion       0

/* Return name of current DOS app in given VM. */
#define apiDosName          1

/* Register callback function with VxD. */
#define apiRegister         2

/* Cancel an in-progress query. */
#define apiCancel           3

/* Return values. */
#define wOk             0   /* Successfully scheduled. */
#define wBadVMHandle    1   /* Invalid VM handle. */
#define wInProgress     2   /* Query in progress. */
#define wVMNotExec      3   /* VM is not executing. */
#define wOutOfMemory    4   /* Could not get a selector. */

/* Notification status. */
#define wStatusOk       0   /* Application path found. */
#define wStatusNoApp    1   /* Command processor only. */
#define wStatusBadPsp   2   /* PSP is messed up. */
