/* Listing Eight */
/*   Title:  STEPISR.H                               *
 *  Author:  John Reynolds                           *
 * Purpose:  Stepper Motor Control Using             *
 *           Real Time Clock For Timing Control      *
 * Copyright 1991 Magnetic Technologies Corporation  *
 *           Rochester, New York  14625              */

#ifndef STEPISR_H
#define STEPISR_H

#define BOOLEAN int
#define FALSE 0
#define TRUE  1

extern BOOLEAN keybreak, sound_on, mech_home;
extern BOOLEAN eot_cw_stop,eot_ccw_stop, *eot_stop_ptr;

unsigned int move_stepper (
   long int steps,
   float velocity,
   float accel,
   int clk_freq_hz        );
/* clk_freq_hz = 128, 1024, or 4096 ONLY!! */
#endif