//-------------------------------------------------------------------------
// SSAVER.C
// Written by Scott A. Mintz
//
// Compiler (Borland C++ 3.1):
//  bcc -W saver.c
//-------------------------------------------------------------------------

#include <windows.h>

#ifndef SPI_GETSCREENSAVEACTIVE
#error This program requires the Windows(tm) 3.1 header file
#endif

int PASCAL WinMain(
                    HINSTANCE hInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR     lpCmdLine,
                    int       nCmdShow )
{
  char szSSName[128];
  BOOL bSSActive;

  (void)hInstance;        // avoid unused args warnings
  (void)hPrevInstance;
  (void)lpCmdLine;
  (void)nCmdShow;

  SystemParametersInfo( SPI_GETSCREENSAVEACTIVE, 
                  0, &bSSActive, FALSE );

  if( bSSActive &&
      GetPrivateProfileString( "boot", 
                               "SCRNSAVE.EXE", 
                               "", 
                               szSSName, 
                               sizeof( szSSName ), 
                               "SYSTEM.INI" ) )
    {
    lstrcat( szSSName, " -s" );
    WinExec( szSSName, SW_SHOW );
    }
  else
    MessageBox( NULL, "There is no screen saver is installed.",
                "Information", MB_OK | MB_ICONINFORMATION );

  return 0;
}
