/*
 * Test routine for the timer functions
 * Compile (Borland C++):
 *  bcc testtime.c timer.obj
 */

#include    <stdio.h>
#include    <dos.h>
#include    <conio.h>
#include    "timer.h"

void main()
{
    long    start_time;
    long    stop_time;
    unsigned long time;
    long    i,j;
    initializetimer();

    start_time = readtimer();
    msleep(571);
    stop_time=readtimer();
    printf ("start_time = %ld, stop_time = %ld\n",
        start_time, stop_time);
    time = elapsedtime(start_time, stop_time);
    printf("time of a 'msleep(571)' call   : %6.3f s  (%ld ms)\n",
        time/1000., time);


    printf("\n\nPress any key to start the timer...\n");
    if (!getch())
        getch();
    start_time=readtimer();

    printf("\nTiming until you press a key...");
    if (!getch())
        getch();
    stop_time = readtimer();
    time = elapsedtime(start_time, stop_time);
    printf("\b\b\b\b\b\b\b\b\bed a key: %6.3f s  (%ld ms)\n",
        time/1000., time);

    restoretimer();
}
