/*****************************************************
Name:
   BINDCTLS.H, Listing 2
File Type:
   Include
Description:
   Include for for BINDCTLS.C
Portability:
   MS Windows
*****************************************************/

#if !defined ( BINDCTLS_DEFINED )
#define BINDCTLS_DEFINED

/* Bind data information structure */
typedef struct tagBINDCTLDATA
   {
   int iCtlId;
   LPARAM lpData;
   } BINDCTLDATA, FAR *LPBINDCTLDATA;

/* Wnd Extra byte offset for BINDEDIT data pntr */
#define GWL_BINDEDIT 6

/* Wnd Extra byte offset for BINDBUTTON data pntr */
#define GWL_BINDBUTTON 4

/* message for BINDEDIT and BINDBUTTON controls */
#define WM_USER_BINDDATA ( WM_USER + 1000 )

/* Prototypes of functions in BINDCTLS.C */
LRESULT BindCtlData( HWND hWnd, LPARAM lParam );
LRESULT CALLBACK CtlProcBindButton( HWND hWnd,
      UINT uiMsg, WPARAM wParam, LPARAM lParam );
LRESULT CALLBACK CtlProcBindEdit( HWND hWnd,
      UINT uiMsg, WPARAM wParam, LPARAM lParam );
BOOL RegisterBindButton( HINSTANCE hInstance );
BOOL RegisterBindDialog( HINSTANCE hInstance );
BOOL RegisterBindEdit( HINSTANCE hInstance );
LRESULT CALLBACK WndProcBindDialog( HWND hWnd,
      UINT uiMsg, WPARAM wParam, LPARAM lParam );

#endif   /* #if !defined ( BINDCTLS_DEFINED ) */

/* End of BINDCTLS.H */
