REM bldwait.bat - Build the wait-for-task-terminate demo
REM ----------------------------------------------------
@set CCFILES=demowait.c
@if NOT "%cc%"=="bcc" goto NOTBCC
bcc -c -xc -DSTRICT -ml! -WDE -vi wait.c
tlink /A=16 /c /C /l /s /Twd c0dl.obj+wait.obj,wait.dll,,cwl+import,wait.def
implib wait.lib wait.dll
bcc -ml -DSTRICT -WSE -vi %CCFILES% wait.lib
@goto END
:NOTBCC
@if NOT "%cc%"=="msc" goto NOTMSC
cl /c /DSTRICT /nologo /W3 /Zp /GDs /GEdme /ALw wait.c
link /nologo /NOE /align:16 /NOD /MAP:FULL /LINE wait,wait.dll,,ldllcew+libw+toolhelp,wait;
implib wait.lib wait.dll
cl /c /DSTRICT /nologo /W3 /Zp /GAs /GEsme /AL %CCFILES%
link /nologo /NOE /align:16 /NOD /MAP:FULL /LINE demowait,,demowait,llibcew+libw+wait,demowait;
@goto END
:NOTMSC
@if NOT "%cc%"=="wcc"  goto NOTWC
wcl -l=windows_dll -bd -ml -zW -zu wait.c toolhelp.lib
wlib -q -n wait.lib +wait.dll
wcl -dSTRICT -w3 -zWs -bt=windows -ml %CCFILES% wait.lib
@goto END
:NOTWC
@if NOT "%cc%"=="sc"  goto NOTSC
sc -c -DSTRICT -a1 -mlwu -W2 wait.c
link /nologo /map wait,wait.dll,,toolhelp+libw,wait.def
implib wait.lib wait.dll
sc -DSTRICT -a1 -ml -W3 %CCFILES% wait.lib
@goto END
:NOTSC
@echo To use this batch file, set your CC environment variable to:
@echo   bcc     - if you are using Borland C++ v4.02
@echo   msc     - if you are using Microsoft Visual C++ v1.5
@echo   wcc     - if you are using Watcom C++ v10.0
@echo   sc      - if you are using Symantec C++ v6.10
:END
@set CCFILES=

