/*
	File: Generic.cpp
	Author: Raja
	Date: 12/05/1995.

	Generated using AppWizard. Only changes are:
	InitInstance: Register CTL3D.DLL with the Auto Subclassing option.
	ExitInstance: Unregister CTL3D.DLL
	Command handlers for launching the dialog boxes.
*/

#include "stdafx.h"
#include "generic.h"

#include "mainfrm.h"
#include "generdoc.h"
#include "genervw.h"
#include "ctl3d.h"

#include "dialog1.h"
#include "dialog2.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGenericApp

BEGIN_MESSAGE_MAP(CGenericApp, CWinApp)
	//{{AFX_MSG_MAP(CGenericApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_TEST_CDIALOG, OnTestCdialog)
	ON_COMMAND(ID_TEST_ZDIALOG, OnTestZdialog)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGenericApp construction

CGenericApp::CGenericApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CGenericApp object

CGenericApp NEAR theApp;

/////////////////////////////////////////////////////////////////////////////
// CGenericApp initialization

BOOL CGenericApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

// Load CTL3D.DLL

	Ctl3dRegister (m_hInstance);
	Ctl3dAutoSubclass (m_hInstance);

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_GENERITYPE,
		RUNTIME_CLASS(CGenericDoc),
		RUNTIME_CLASS(CMDIChildWnd),        // standard MDI child frame
		RUNTIME_CLASS(CGenericView));
	AddDocTemplate(pDocTemplate);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// create a new (empty) document
	OnFileNew();

	if (m_lpCmdLine[0] != '\0')
	{
		// TODO: add command line processing here
	}

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	return TRUE;
}

int CGenericApp::ExitInstance ()
{
	Ctl3dUnregister (m_hInstance);
	return CWinApp::ExitInstance ();
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CGenericApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CGenericApp commands

void CGenericApp::OnTestCdialog()
{
	CDialog1 dlg1;
	dlg1.DoModal ();
}

void CGenericApp::OnTestZdialog()
{
	CDialog2 dlg2;
	dlg2.DoModal ();
}
