/*
	File: ZDialog.h
	Author: Raja
	Date: May 12, 1995.

	The ZDialog class: Making CTL3D.DLL and OnCtlColor work together. 
*/

#ifndef __ZDIALOG__
#define __ZDIALOG__

class ZDialog : public CDialog
{
public:
	ZDialog (UINT nID, CWnd *pParent = NULL);
	ZDialog (LPCSTR lpszTemplateName, CWnd *pParent = NULL);

protected:
	ZDialog ();

protected:
	virtual BOOL OnInitDialog ();

// Implementation.
protected:

#ifndef WIN32
	static LRESULT FAR PASCAL _export ZDialogProcedure (HWND hWnd, UINT message, 
					WPARAM wParam, LPARAM lParam);
	HBRUSH OnCtlColor (CDC *pDC, CWnd *pWnd, UINT nCtlColor);
#endif // WIN32

	DECLARE_MESSAGE_MAP()        
	DECLARE_DYNAMIC (ZDialog)

private:
	WNDPROC m_oldDlgProc;	// Stores the original dlgproc address.
};
#endif //__ZDIALOG__

