/*////////////////////////////////////////////////////////////////////////////

    MODULE:    PICDLL.H
    
    Description:
        This module contains global definitions and things for the DLL
        version of the pic controls.  If _PICDLL is defined, the PICAPI
        constant will be _export, and if not, it will be nothing.  This
        will enable us to build static lib versions of the controls as
        well as a DLL version.
        
    History:                           
        Date        Email       Action
        ----------------------------------------------
        10/07/93    daveste     created
        
*/////////////////////////////////////////////////////////////////////////////

#ifndef __PICDLL_H__
#define __PICDLL_H__

#define PICAPI

#ifdef _PICDLL
	#undef AFXAPI_DATA
	#define AFXAPI_DATA __based(__segname("_DATA"))
#endif //_PICDLL

#endif // __PICDLL_H__