; Written by Terje Mathisen, 1995, based upon an idea from Jim Lawless

        .model tiny

        .code
        org     0
return  label   near

        org     5ch
maxlen  db      ?
datalen db      ?
buffer  db      5ch dup (?)

        org     100h
start:
        mov     ax,0f000h
        mov     sp,ax
        jmp     high_start

        org     0fc9h

next_block:
        xor     ax,ax
        xor     bp,bp
        mov     bl,5            ; 5 input chars/4-byte output block!
next_char:
        inc     si
        xchg    ax,bp           ; Mul old value by 85
        mul     di
        xchg    ax,bp
        mul     di
        mov     cx,256-21h
        add     cl,[si]
        add     ax,cx           ; and add in the current char (-21h)
        adc     bp,dx
        dec     bl
         jnz    next_char

        push    bp              ; Save this block (reverse order!)
        push    ax
        sub     bh,5            ; More blocks?
         ja     next_block

high_start:
        mov     ah,0ah  ; Get line from stdin!
        mov     si,offset maxlen
        mov     dx,si
        mov     [si],dl
        inc     si
        int     21h
        mov     bh,[si]
        mov     di,85   ; 85^5 > 2^32
        test    bh,bh
         jnz    next_block

        int     3               ; Breakpoint to stop program!

        end     start

