#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef unsigned long ulong;
typedef unsigned int  uint;

#define MAXSIZE 0xfec8

void prolog(void)
{
   printf(
    "eFFC9 33 C0 33 ED B3 5 46 95 F7 E7 95 F7 E7 B9 DF 0 2 C\n"\
    "eFFDB 3 C1 13 EA FE CB 75 EC 55 50 80 EF 5 77 DF B4 A BE\n"\
    "eFFED 5C 0 8B D6 88 14 46 CD 21 8A 3C BF 55 0 84 FF 75 CA CC\n");
}

void encodefile(ulong *buf, uint size, char *filename)
{
   ulong *b, u;
   int p, i;
   char c[6];

   printf(
    "rsp\n"\
    "%x\n"\
    "g=ffea\n",0x100 + ((size + 3) & (~3)));

   c[5] = '\0'; p = 0;
   for (b = (buf + ((size+3)>>2));b-- > buf; ) {

      for (u = *b, i = 4; i > 0; i-- ) {
         c[i] = (u % 85) + 0x21;
         u /= 85;
      }
      c[0] = u + 0x21;

      printf("%s",c);
      if ((p += 5) >= 70) {
         printf("\n");
         p = 0;
      } /* endif */
   } /* endfor */

   if (p) printf("\n"); /* Flush any partial line! */

   printf("\n");    /* End with a blank line! */

   printf("rcx\n%x\n",size);
   printf("n%s\n",filename);
   printf("w\n");
}                                       

void epilog(void)
{
   printf("q\n");       /* Quit from DEBUG! */
}

char *filestem(char *filename)
{
  char *stem;

  stem = strrchr(filename,'\\');           
  if (!stem)
    stem = strrchr(filename,':');
  if (stem)
    stem++;
  else
    stem = filename;
  return stem;
}

int main(int argc, char *argv[])
{
   ulong *buf, filesize;
   uint size;
   FILE *f;
   char filename[80], *stem, *ext;

   if (argc < 2) {
      fprintf(stderr,"Usage: dbencode filename > output_file\n");
      return 1;
   }
   buf = (ulong *) malloc(MAXSIZE);
   if (!buf) {
      fprintf(stderr,"Could not allocate %x bytes!\n",MAXSIZE);
      return 1;
   } /* endif */

   strcpy(filename,argv[1]);
   strlwr(filename);
   stem = filestem(filename);
   ext = strrchr(stem,'.');
   if (!ext) ext = "";      /* dummy name for strlen() call later! */

   f = fopen(filename,"rb");
   if (!f) {
      fprintf(stderr,"Could not open %s!\n",argv[1]);
      return 1;
   } /* endif */

   fseek(f,0l,SEEK_END);
   filesize = ftell(f);
   fseek(f,0,SEEK_SET);

   prolog();
   if ((filesize > MAXSIZE) || 
       ((strlen(ext) == 4) && (strstr(".exe.com.sys.ovl.bin",ext) != NULL))) {

      /* Do one or more renamed blocks! */

      int p = 0;
      char batfile[256] = "copy /b ", temp[] = "$.$$";
      ext = strrchr(temp,'.');  

      while ((size = fread(buf,1,MAXSIZE,f)) > 0) {
         ext[2] = (p % 10) + '0';
         if (p > 9) ext[1] = (p / 10) + '0';
         encodefile(buf,size,temp);

         if (p < 24) {
           if (p) strcat(batfile,"+");
           strcat(batfile,temp);
         } /* endif */
         p++;
      }
      if (p < 24) {
        strcat(batfile," ");
        strcat(batfile,filestem(argv[1]));
        strcat(batfile,"\r\ndel $.$*\r\n");
        encodefile((ulong *) batfile,strlen(batfile),"dbtemp.bat");
      } /* endif */
   } else {
      size = fread(buf,1,MAXSIZE,f);
      encodefile(buf,size,filestem(argv[1]));
   } /* endif */
   fclose(f);

   epilog();

   return 0;
}

