// clnt.c

#include <windows.h>
#include <tchar.h>
#include "wdj_iocp.h"

void main(void)
{
   HANDLE hPipe;
   DWORD  dwMode = PIPE_READMODE_MESSAGE | PIPE_WAIT;
   TCHAR  RdBuffer[MAX_PATH], WrBuffer[MAX_PATH];
   int    i, Size;
   DWORD  dwProcessId = GetCurrentProcessId();

   if (!WaitNamedPipe(PIPE_NAME, 5000)) return;

   hPipe = CreateFile(PIPE_NAME, GENERIC_READ|GENERIC_WRITE,
       0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);

   SetNamedPipeHandleState(hPipe, &dwMode, NULL, NULL);

   for (i=0; i < 5000; i++) {
      wsprintf(WrBuffer,TEXT("Client-%d-%d"),dwProcessId,i);
      Size = (lstrlen(WrBuffer)+1) * sizeof(TCHAR);

      if (!TransactNamedPipe(hPipe, &WrBuffer, Size,
            RdBuffer, READ_BUFFER, &Size, NULL)) {
         CloseHandle(hPipe);
         return;
      }
      _tprintf(TEXT("Client: %s, %d\n"), RdBuffer, Size);
   }

   CloseHandle(hPipe);
}


