// nettttDlg.cpp : implementation file
//

#include "stdafx.h"
#include "netttt.h"
#include "csockobj.h"
#include "nettttDlg.h"
#include "connect.h"
#include "tranobj.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////
// CMyObjectSocket
void CMyObjectSocket::OnForcedDrop()
{
	pMainDlg->UpdateStatus();
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNettttDlg dialog

CNettttDlg * pMainDlg = NULL;

void CNettttDlg::CreateGameBoard()
{
	CRect rect;
	m_PicBoard.GetWindowRect(&rect);
	ScreenToClient(&rect);
	pGame = new CTTTWnd();
	pGame->Create(NULL,"GameBoard",WS_CHILD|WS_VISIBLE,rect,this,1001);

}

CNettttDlg::CNettttDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNettttDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNettttDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	pGame = NULL;
	m_nLineScroll = 0;
}

void CNettttDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNettttDlg)
	DDX_Control(pDX, IDC_STATUS, m_Status);
	DDX_Control(pDX, IDC_SENDBUT, m_SendBut);
	DDX_Control(pDX, IDC_PICBOARD, m_PicBoard);
	DDX_Control(pDX, IDC_NEWMESSAGE, m_NewMessage);
	DDX_Control(pDX, IDC_MESSAGEBOARD, m_MessageBoard);
	DDX_Control(pDX, IDC_HOSTBUT, m_HostBut);
	DDX_Control(pDX, IDC_DROPBUT, m_DropBut);
	DDX_Control(pDX, IDC_CONNECTBUT, m_ConnectBut);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CNettttDlg, CDialog)
	//{{AFX_MSG_MAP(CNettttDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CONNECTBUT, OnConnectbut)
	ON_BN_CLICKED(IDC_DROPBUT, OnDropbut)
	ON_BN_CLICKED(IDC_HOSTBUT, OnHostbut)
	ON_EN_CHANGE(IDC_NEWMESSAGE, OnChangeNewmessage)
	ON_BN_CLICKED(IDC_SENDBUT, OnSendbut)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNettttDlg message handlers

BOOL CNettttDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	//m_Status.FmtLines(TRUE);
	//m_NewMessage.FmtLines(TRUE);
	//m_MessageBoard.FmtLines(TRUE);
	
	pMainDlg = this;
	UpdateStatus();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CNettttDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CNettttDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CNettttDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CNettttDlg::OnConnectbut() 
{
	CFindHost fh(this);
	if (IDOK == fh.DoModal())
	{
		if (m_ObjSocket.Connect(fh.m_Address,751))
		{
			m_LocalName = fh.m_Name;
			m_RemoteName = "";
			UpdateStatus();
			CSendName sn(m_LocalName);
			m_ObjSocket.SendObject(&sn);
			
			CreateGameBoard();
			CTurn * p = new CTurn(FALSE);
			m_ObjSocket.SendObject(p);

			p->m_IsX = TRUE;
			p->m_LocalTurn = TRUE;
			pGame->AddTurn(p);
		}
		else
		{
			MessageBox("Could not find host","Net Tic-Tac-Toe");
		}
	} 
}

void CNettttDlg::OnDropbut() 
{
	if (m_ObjSocket.IsConnected())
	{
		m_ObjSocket.Disconnect();
	}
	UpdateStatus();
}

void CNettttDlg::UpdateStatus()
{
	CString tmp;
	if (!m_ObjSocket.IsConnected())
	{
		tmp = "Not Connected";
		m_SendBut.EnableWindow(FALSE);
		m_NewMessage.SetWindowText("");
		m_NewMessage.EnableWindow(FALSE);
		m_MessageBoard.SetWindowText("");
		m_HostBut.EnableWindow(TRUE);
		m_DropBut.EnableWindow(FALSE);
		m_ConnectBut.EnableWindow(TRUE);
		m_RemoteName = "";
		if (pGame)
		{
			pGame->DestroyWindow();
			delete pGame;
			pGame = NULL;
		}
	}
	else
	{
		m_NewMessage.EnableWindow(TRUE);
		m_HostBut.EnableWindow(FALSE);
		m_DropBut.EnableWindow(TRUE);
		m_ConnectBut.EnableWindow(FALSE);

		int i = m_MessageBoard.GetLineCount();
		m_MessageBoard.SetWindowText(m_MsgBoard);
		i--;
		m_MessageBoard.LineScroll(m_nLineScroll);
		m_nLineScroll = i;

		tmp = "Connected to ";
		if (m_LocalName.GetLength() < 1)
		{
			tmp += "Unknown";
		}
		else
		{
			tmp += m_RemoteName;
		}
		if (pGame)
		{
			tmp += "\r\n";
			tmp += "You are ";
			if (pGame->m_pTurn->m_IsX)
			{
				tmp += "X's\r\n";
			}
			else
			{
				tmp += "0's\r\n";
			}
		}
	} 
	m_Status.SetWindowText(tmp);
}

void CNettttDlg::OnHostbut() 
{
	CHostSetup cSetDlg(this);

	if (IDOK != cSetDlg.DoModal())
	{
		return;
	}
	CConnect cConDlg(this);
	if (IDOK == cConDlg.DoModal())
	{
		CWaitCursor wc;
		if (m_ObjSocket.Connect(&cConDlg.m_ListenSock))
		{
			MessageBeep(0);
			m_LocalName = cSetDlg.m_Name;
			m_RemoteName = "";
			UpdateStatus();
			CSendName sn(m_LocalName);
			m_ObjSocket.SendObject(&sn);
			return;
		}
		MessageBox("Failed to make connection!","Net Tic-Tac-Toe");
	}
}

void CNettttDlg::OnChangeNewmessage() 
{
	CString tmp;
	m_NewMessage.GetWindowText(tmp);
	if (tmp.GetLength() > 0)
	{
		m_SendBut.EnableWindow(TRUE);
	}
	else
	{
		m_SendBut.EnableWindow(FALSE);
	}
	
}

void CNettttDlg::OnSendbut() 
{
	CSendMessage sm(this);
	m_ObjSocket.SendObject(&sm);
}
/////////////////////////////////////////////////////////////////////////////
// CTTTWnd

CTTTWnd::CTTTWnd()
{
	m_pTurn = NULL;
}

CTTTWnd::~CTTTWnd()
{
	if (m_pTurn)
	{
		delete m_pTurn;
		m_pTurn = NULL;
	}
}


BEGIN_MESSAGE_MAP(CTTTWnd, CWnd)
	//{{AFX_MSG_MAP(CTTTWnd)
	ON_WM_PAINT()
	ON_WM_DESTROY()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CTTTWnd message handlers
CRect CTTTWnd::GetBox(int space, CRect& r)
{
	CRect box;
	int colW,rowH;
	colW = r.Width() /3;
	rowH = r.Height() /3;
	
	int col,row;
	if ((space == 0)||(space == 3)||(space == 6))
	{
		col = 0;
	}
	else
	{
		if ((space == 1)||(space == 4)||(space == 7))
		{
			col = 1;
		}
		else
		{
			col = 2;
		}
	}
	
	if (space < 3)
	{
		row = 0;
	}
	else
	{
		if (space < 6)
		{
			row = 1;
		}
		else
		{
			row = 2;
		}
	}

	box.TopLeft().x = (col * colW) + 5;
	box.TopLeft().y = (row * rowH) + 5;
	box.BottomRight().x = (box.TopLeft().x + colW) - 10;
	box.BottomRight().y = (box.TopLeft().y + rowH) - 10;
	return box;
}

void CTTTWnd::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	if (m_pTurn == NULL) return;
	CRect rect;
	GetClientRect(&rect);
	rect.left += 2;
	rect.top += 2;
	rect.bottom -= 2;
	rect.right -= 2;

	CBrush white(RGB(255,255,255));
	dc.FillRect(rect,&white);

	CPen black(PS_SOLID,2,RGB(0,0,0));
	CPen gray(PS_SOLID,2,RGB(150,150,150));
	CPen red(PS_SOLID,5,RGB(255,0,0));
	CPen redDull(PS_SOLID,5,RGB(150,0,0));
	CPen blue(PS_SOLID,5,RGB(0,0,255));
	CPen blueDull(PS_SOLID,5,RGB(0,0,150));
	CPen green(PS_SOLID,8,RGB(0,255,0));
	CPen greenDull(PS_SOLID,8,RGB(0,150,0));

	//Draw Tic-Tac-Toe board
	CPen *pOldPen;
	if (m_pTurn->m_LocalTurn)
	{
		pOldPen = dc.SelectObject(&black);
	}
	else
	{
		pOldPen = dc.SelectObject(&gray);
	}
	dc.MoveTo((rect.right -rect.left)/3,rect.top + 5);
	dc.LineTo((rect.right -rect.left)/3,rect.bottom - 5);
	dc.MoveTo((rect.right -rect.left)/3*2,rect.top + 5);
	dc.LineTo((rect.right -rect.left)/3*2,rect.bottom - 5);
	dc.MoveTo(rect.left + 5,(rect.bottom -rect.top)/3);
	dc.LineTo(rect.right - 5,(rect.bottom -rect.top)/3);
	dc.MoveTo(rect.left + 5,(rect.bottom -rect.top)/3*2);
	dc.LineTo(rect.right - 5,(rect.bottom -rect.top)/3*2);
	dc.SelectObject(pOldPen);
	//Draw X's & O's
	CRect box;
	for (int i = 0;i < 9;i++)
	{
		if (m_pTurn->IsUsedSpace(i))
		{
			box = GetBox(i,rect);
			if (m_pTurn->IsXMark(i))
			{
				if (m_pTurn->m_LocalTurn)
				{
					pOldPen = dc.SelectObject(&red);
				}
				else
				{
					pOldPen = dc.SelectObject(&redDull);
				}
				dc.MoveTo(box.TopLeft());
				dc.LineTo(box.BottomRight());
				dc.MoveTo(box.TopLeft().x,box.BottomRight().y);
				dc.LineTo(box.BottomRight().x,box.TopLeft().y);
			}
			else //YMark
			{
				if (m_pTurn->m_LocalTurn)
				{
					pOldPen = dc.SelectObject(&blue);
				}
				else
				{
					pOldPen = dc.SelectObject(&blueDull);
				}
				dc.Ellipse(&box);
			}
			dc.SelectObject(pOldPen);
		}
	}
	
	int s,f,place;
	if (m_pTurn->HasWon(&s,&f))
	{	
		if (m_pTurn->m_LocalTurn)
		{
			pOldPen = dc.SelectObject(&green);
		}
		else
		{
			pOldPen = dc.SelectObject(&greenDull);
		}
		CRect start,finish;
		start = GetBox(s,rect);
		finish = GetBox(f,rect);
		if (start.TopLeft().y == finish.TopLeft().y)
		{
			place = (start.BottomRight().y - start.TopLeft().y)/2;
			place += start.TopLeft().y;
			dc.MoveTo(start.TopLeft().x,place);
			dc.LineTo(finish.BottomRight().x,place);
		}
		else if (start.TopLeft().x == finish.TopLeft().x)
		{
			place = (start.BottomRight().x - start.TopLeft().x)/2;
			place += start.TopLeft().x;
			dc.MoveTo(place,start.TopLeft().y);
			dc.LineTo(place,finish.BottomRight().y);
		}
		else if (s == 0)
		{
			dc.MoveTo(start.TopLeft());
			dc.LineTo(finish.BottomRight());
		}
		else
		{
			dc.MoveTo(start.BottomRight().x,start.TopLeft().y);
			dc.LineTo(finish.TopLeft().x,finish.BottomRight().y);
		}
		dc.SelectObject(pOldPen);
	}


}

void CTTTWnd::OnDestroy() 
{
	CWnd::OnDestroy();
	
	
}

void CNettttDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	if (pGame)
	{
		pGame->DestroyWindow();
		delete pGame;
		pGame = NULL;
	}

	
}

void CTTTWnd::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	CWnd::OnLButtonUp(nFlags, point);

	if (m_pTurn == NULL) return;
	if (!m_pTurn->m_LocalTurn)
	{
		MessageBeep(0);
		MessageBox("It's not your turn!","Net Tic-Tac-Toe");
		return;
	}

	if (m_pTurn->IsDone())
	{
		int q = MessageBox("Would you like another game?","Net Tic-Tac-Toe",MB_YESNO);
		if (q == IDYES)
		{
			CTurn * p = new CTurn(FALSE);
			pMainDlg->m_ObjSocket.SendObject(p);

			p->m_IsX = TRUE;
			p->m_LocalTurn = TRUE;
			pMainDlg->pGame->AddTurn(p);
		}
		return;
	}
	

	CRect rect;
	GetClientRect(&rect);
	
	int pos;
	//locate Column
	if (point.x < (rect.Width() / 3))
	{
		pos = 0;
	}
	else
	{
		if (point.x <  ((rect.Width() / 3)*2))
		{
			pos = 1;
		}
		else
		{
			pos = 2;
		}
	}
	//locate row
	if (point.y >= (rect.Height() / 3))
	{
		if (point.y < ((rect.Height() / 3)*2))
		{
			pos += 3;
		}
		else
		{
			pos += 6;
		}
	}

	if (m_pTurn->IsUsedSpace(pos))
	{
		MessageBeep(0);
		return;
	}

	CTurn * pNextTurn = m_pTurn->NextTurn(pos);
	InvalidateRect(NULL);

	// For Testing Only
	//AddTurn(pNextTurn);

	pMainDlg->m_ObjSocket.SendObject(pNextTurn);
	delete pNextTurn;
}

void CTTTWnd::AddTurn(CTurn * pTurn)
{
	if (m_pTurn) delete m_pTurn;
	m_pTurn = pTurn;
	InvalidateRect(NULL);
	pMainDlg->UpdateStatus();
}