#ifndef TRANOBJ_H
	#define TRANOBJ_H

class CSendName : public CNetObject
{
	CString m_Name;
public:


	DECLARE_SERIAL(CSendName);

	CSendName() : CNetObject() {}
	CSendName(LPCTSTR name);
	void Serialize(CArchive& ar);
	void DoAction(CObjectSocket * pOS);
};

class CSendMessage : public CNetObject
{
	CString m_Message;
public:
	DECLARE_SERIAL(CSendMessage);

	CSendMessage() : CNetObject() {}
	CSendMessage(CNettttDlg * pnd);

	void Serialize(CArchive& ar);
	void DoAction(CObjectSocket * pOS);
};

#define XMARK   1
#define YMARK   2
#define NOMARK  0

class CTurn : public CNetObject
{
	int m_Board[9];	
public:
	DECLARE_SERIAL(CTurn)
	BOOL m_LocalTurn;
	BOOL m_IsX;

	CTurn(): CNetObject() {}
	CTurn(BOOL LocalFirst);

	CTurn * NextTurn(int MarkedBox);
	BOOL HasWon(int * BoxStart = NULL,int *  BoxEnd = NULL);
	BOOL IsDone();
	BOOL IsUsedSpace(int space);
	BOOL IsXMark(int space);
	
	void Serialize(CArchive& ar);
	void DoAction(CObjectSocket * pOS);
};

#endif //TRANOBJ_H


