/////////////////////////////////////////////////
//
// SHBrowse.h : Windows 4 Shell directory browser
//

#if !defined (_SHBrowse_H_)
#define _SHBrowse_H_

#include <winnetwk.h>
#include <shlobj.h>

/////////////////////////////////////////////////
//
// CShellBrowser
//
class CShellBrowser
{
// Construction
public:
   CShellBrowser(HWND hParent, int nTitleID=0);

// Attributes (implementation)
protected:
   BROWSEINFO m_BrowseInfo;
   char m_szTitle[MAX_PATH];
   char m_szDirectory[MAX_PATH];

// Interface
public:
   BOOL SelectFolder(void);
   void SetTitle(LPCSTR szTitle);
   void SetTitle(int nTitle);
   LPCSTR GetSelectedFolder(void);
   BROWSEINFO* GetBrowseInfo(void);
};

#endif
