// nictest.c -- demonstrate GetNICAddress() function

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>

#define MAX_NIC_LEN	15

BOOL GetNICAddress(LPSTR buf, UINT cbbuf);


int main(int argc, char *argv[])
{
    char    szNIC[MAX_NIC_LEN + 1];

    if (GetNICAddress(szNIC, MAX_NIC_LEN))
        printf("Success: NIC address = %s\n", szNIC);
    else
        printf("Can't retrieve NIC address.\n");

    return(0);
}
