@echo off
rem !! Builds the following:
rem !!   demo1a.exe - ANSI version with runtime library
rem !!   demo2a.exe - ANSI version without runtime library
rem !!   demo1w.exe - Unicode version with runtime library
rem !!   demo2w.exe - Unicode version without runtime library
rem !!
rem !! The '/fixed' option removes the relocations section from the
rem !! .exe file.  Unlike .dlls, .exes never need to be relocated
rem !! at load-time, so you can save space by removing the relocations
rem !! section.  VC 5.0 uses '/fixed' by default, but VC 4.0 does not.
rem !! See "A Tool to Strip .reloc Sections" by Michael Sperry in the
rem !! October 1997 issue of WDJ.

cl demo.c /link /out:demo1a.exe /fixed kernel32.lib user32.lib
cl demo.c nocrt.c /link /out:demo2a.exe /fixed kernel32.lib user32.lib
cl /DUNICODE demo.c /link /out:demo1w.exe /fixed kernel32.lib user32.lib
cl /DUNICODE demo.c nocrt.c /link /out:demo2w.exe /fixed kernel32.lib user32.lib
