/* 
 *  JUNK.C
 *  Written by Fred Smith
 *
 *  Sample application which reads from stdin and writes to the
 *  file named as the first command-line parameter.
 *
 *  Compile:
 *      bcc junk.c
 */

#include <stdio.h>
#include <stdlib.h>

main (int argc, char ** argv)
{
    FILE * junk;

    if ((junk = fopen (argv[1], "w")) == (FILE *)0)
        exit (0);
    while (feof (stdin) == 0)
    {
        fputc (fgetc (stdin), junk);
    }
    fclose (junk);
    return 0;
}
