/* 
   WIN32PSX.H

   Header file that defines the data structures
   and packet types used for sending requests from
   POSIX to WIN32 server process. */

struct Request_Header {
unsigned char	rh_type,
#define RPC_REQUEST	1
#define RPC_REPLY	2
		rh_hdrsize, /* Sizeof(Request_Header)*/
		rh_pad0,
		rh_pad1;    /* alignment */
	long	rh_size,    /* Size of user data */
		rh_chan,    /* unique ID */
		rh_request; /* function request */
	/* The data of rh_size is sent after the header */
};

/* Send a NULL RPC request and return TRUE status */

int NoopRPC();
#define RPC_NOOP		1

/* Request WIN32SRV to run the command line, wait,
   then return the exit status. */

int SystemRPC(char *command_line);
#define RPC_RUN_SHELL_CMD_SYNC	2

/* Connect to the server */
void AttachToServer();

/* Path to the named pipes for POSIX */
#define NAMED_PIPE_PATH	""
