/*****************************************************/
/* symhook.h                                         */
/* -- Interface to hook functions for hook           */
/*    framework.                                     */
/*****************************************************/

/* Hook functions. */
BOOL WINAPI HookExtTextOut(HDC, int, int, UINT, LPRECT,
            LPSTR, UINT, LPINT);
BOOL WINAPI HookGetCharWidth(HDC, UINT, UINT, LPINT);
BOOL WINAPI HookGetTextMetrics(HDC, LPTEXTMETRIC);

/* Hook data array. */
#ifdef  DEFINE_HOOKS
HKS     rghks[] =
    {
        {
        (FARPROC)GetCharWidth, 0xea,
        (FARPROC)HookGetCharWidth
        },
        {
        (FARPROC)ExtTextOut, 0xea,
        (FARPROC)HookExtTextOut
        },
        {
        (FARPROC)GetTextMetrics, 0xea,
        (FARPROC)HookGetTextMetrics
        },
        {
        NULL, 0, NULL,
        }
    };
#else  /*!DEFINE_HOOKS*/
extern  HKS rghks[];
#endif  /*DEFINE_HOONS*/

/* Hook data array entries. */
#define phksGetCharWidth    rghks
#define phksExtTextOut      (rghks + 1)
#define phksGetTextMetrics  (rghks + 2)
