/*****************************************************/
/* symhook.h                                         */
/* -- Interface to hook functions for hook           */
/*    framework.                                     */
/*****************************************************/

/* Hook functions. */
BOOL  WINAPI _export HookExtTextOut(HDC, int, int, UINT,
                    LPRECT, LPSTR, UINT, LPINT);
DWORD WINAPI _export HookGetTextExtent(HDC, LPSTR, int);

/* Hook data array. */
#ifdef  DEFINE_HOOKS
HKS     rghks[] =
    {
        {
        (FARPROC)ExtTextOut, 0xea,
        (FARPROC)HookExtTextOut
        },
        {
        (FARPROC)GetTextExtent, 0xea,
        (FARPROC)HookGetTextExtent
        },
        {
        NULL, 0, NULL,
        }
    };
#else   /*!DEFINE_HOOKS*/
extern  HKS rghks[];
#endif  /*!DEFINE_HOOKS*/

/* Hook data array entries. */
#define phksExtTextOut     rghks
#define phksGetTextExtent  (rghks + 1)
