REM bldactiv.bat - Build the active window tracking demo
REM ----------------------------------------------------
@set CCFILES=demoactv.c
@if NOT "%cc%"=="bcc" goto NOTBCC
bcc -c -xc -DSTRICT -ml! -WDE -vi activtrk.c
tlink /A=16 /c /C /l /s /Twd c0dl.obj+activtrk.obj,activtrk.dll,,cwl+import,activtrk.def
implib activtrk.lib activtrk.dll
bcc -ml -DSTRICT -WSE -vi %CCFILES% activtrk.lib
@goto END
:NOTBCC
@if NOT "%cc%"=="msc" goto NOTMSC
cl /c /DSTRICT /nologo /W3 /Zp /GDs /GEdme /ALw activtrk.c
link /nologo /NOE /align:16 /NOD /MAP:FULL /LINE activtrk,activtrk.dll,,ldllcew+libw,activtrk;
implib activtrk.lib activtrk.dll
cl /c /DSTRICT /nologo /W3 /Zp /GAs /GEsme /AL %CCFILES%
link /nologo /NOE /align:16 /NOD /MAP:FULL /LINE demoactv,,demoactv,llibcew+libw+activtrk,demoactv;
@goto END
:NOTMSC
@if NOT "%cc%"=="wcc"  goto NOTWC
wcl -l=windows_dll -bd -ml -zW -zu activtrk.c
wlib -q -n activtrk.lib +activtrk.dll
wcl -dSTRICT -w3 -zWs -bt=windows -ml %CCFILES% activtrk.lib
@goto END
:NOTWC
@if NOT "%cc%"=="sc"  goto NOTSC
sc -c -DSTRICT -a1 -mlwu -W2 activtrk.c
link /nologo /map activtrk,activtrk.dll,,,activtrk.def
implib activtrk.lib activtrk.dll
sc -DSTRICT -a1 -ml -W3 %CCFILES% activtrk.lib
@goto END
:NOTSC
@echo To use this batch file, set your CC environment variable to:
@echo   bcc     - if you are using Borland C++ v4.02
@echo   msc     - if you are using Microsoft Visual C++ v1.5
@echo   wcc     - if you are using Watcom C++ v10.0
@echo   sc      - if you are using Symantec C++ v6.10
:END
@set CCFILES=

