REM bldmalloc.bat - Build the Memory allocation demo
REM --------------------------------------------
@set CCFILES=malloc.c dlg3d.c
@if NOT "%cc%"=="bcc" goto NOTBCC
rc -r malloc.rc
bcc -c -xc -DSTRICT -ml -WDE -vi -v lmalloc.c
tlink /A=16 /c /C /l /s /Twd c0dl.obj+lmalloc.obj,lmalloc.dll,,cwl+import,lmalloc.def
implib lmalloc.lib lmalloc.dll
bcc -DSTRICT -WSE -vi -ml -P %CCFILES% lmalloc.lib
rc malloc.res malloc.exe
@goto END
:NOTBCC
@if NOT "%cc%"=="msc" goto NOTMSC
rc -r malloc.rc
cl /c /DSTRICT /nologo /W3 /Zp /GDs /GEdme /ALw lmalloc.c
link /nologo /NOE /align:16 /NOD /MAP:FULL /LINE lmalloc,lmalloc.dll,,ldllcew+libw,lmalloc;
implib lmalloc.lib lmalloc.dll
cl /c /DSTRICT /nologo /W3 /Zp /GAs /GEsme /ALw /Tp malloc.c /Tp dlg3d.c
link /nologo /NOE /align:16 /NOD /MAP:FULL /LINE malloc+dlg3d,,malloc,llibcew+libw+toolhelp+lmalloc,malloc;
rc malloc.res malloc.exe
@goto END
:NOTMSC
@if NOT "%cc%"=="wcc"  goto NOTWC
wrc -q -r malloc.rc
wcl  -l=windows_dll -bd -ml -zW -zu lmalloc.c
wlib -q -n lmalloc.lib +lmalloc.dll
wcl -cc++ -dSTRICT -w3 -zWs -bt=windows -ml %CCFILES% lmalloc.lib toolhelp.lib
wrc -q malloc.res malloc.exe
@goto END
:NOTWC
@if NOT "%cc%"=="sc"  goto NOTSC
rc -r malloc.rc
sc -c -DSTRICT -a1 -mlwu -W2 lmalloc.c
link /nologo /map lmalloc,lmalloc.dll,,,lmalloc.def
implib lmalloc.lib lmalloc.dll
sc -cpp -DSTRICT -a1 -ml -W3 %CCFILES% lmalloc.lib toolhelp.lib
REM Due to bug in Symantec C++ v6.1 runtime, following rc
REM produces error.
rc malloc.res malloc.exe
@goto END
:NOTSC
@echo To use this batch file, set your CC environment variable to:
@echo   bcc     - if you are using Borland C++ v4.02
@echo   msc     - if you are using Microsoft Visual C++ v1.5
@echo   wcc     - if you are using Watcom C++ v10.0
@echo   sc      - if you are using Symantec C++ v6.10
:END
@set CCFILES=


