#define VIDEO_SIGNAL_INTERVAL 1000

#ifndef WIN32
	typedef unsigned short * LPWSTR;
	typedef UINT MCIDEVICEID;
#endif

MCIDEVICEID videoOpen(LPSTR lpszFileName, HWND hwndParent,
					  LPRECT lprcRect, HWND hwndSignalCallback);
void        videoClose(MCIDEVICEID mciDeviceID);
BOOL        videoPlay(MCIDEVICEID mciDeviceID,
					  HWND hwndPlayCallback, BOOL fLoop);
void        videoStop(MCIDEVICEID mciDeviceID);
void        videoPause(MCIDEVICEID mciDeviceID);
BOOL        videoSeek(MCIDEVICEID mciDeviceID, DWORD dwPos);
DWORD       videoGetFrameCount(MCIDEVICEID mciDeviceID);
DWORD       videoGetCurrentFrame(MCIDEVICEID mciDeviceID);
void 			videoGetDefaultRect(MCIDEVICEID mciDeviceID,
									LPRECT lprcVideo);
void 			videoUpdate(MCIDEVICEID mciDeviceID, HDC hdc);
