// FP2.CPP
//
//  This program is used to dump the binary representation
//  of a few different values used in FP1.CPP.

#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>

template<class T> void dump( T &t )
{
    unsigned char *p = (unsigned char *) &t;
    for ( int i  = 0 ; i < sizeof( T ) ; i++ )
        cout << setw( 2) << hex << (int) *p++ << ' ';
}

main()
{
    float f = 1.12;
    double d1 = 1.12;
    double d2 = f;

    cout.fill( '0' );
    cout << "f  = " << setprecision( 3 ) << f
         << "  " <<  setprecision( 10 )  << f
         << "  dump: ";
    dump( f );
    cout << "\n";

    cout << "d1 = " << setprecision( 3 ) << d1
         << "  " <<  setprecision( 10 )  << d1
         << "  dump: ";
    dump( d1 );
    cout << "\n";

    cout << "d2 = " << setprecision( 3 ) << d2
         << "  " <<  setprecision( 10 )  << d2
         << "  dump: ";
    dump( d2 );
    cout << "\n";
    return 0;
}

