// connect.cpp : implementation file
//

#include "stdafx.h"
#include "netttt.h"
#include "connect.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHostSetup dialog


CHostSetup::CHostSetup(CWnd* pParent /*=NULL*/)
	: CDialog(CHostSetup::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHostSetup)
	m_Name = _T("");
	//}}AFX_DATA_INIT
}


void CHostSetup::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHostSetup)
	DDX_Text(pDX, IDC_EDIT1, m_Name);
	//}}AFX_DATA_MAP
	if (pDX->m_bSaveAndValidate)
	{
		if (m_Name.GetLength() < 1)
		{
			MessageBox("Name can not be blank!","Net Tic-Tac-Toe");
			pDX->Fail();
		}
	}
}


BEGIN_MESSAGE_MAP(CHostSetup, CDialog)
	//{{AFX_MSG_MAP(CHostSetup)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHostSetup message handlers

//////////////////////////////
// CListenSocket
CListenSocket::~CListenSocket()
{
	Close();
}

BOOL CListenSocket::DidCreate(CConnect * pCon)
{
	ASSERT(pCon);
	m_pConnect = pCon;
	if (Create(751))
	{
		if (Listen())
		{
			return TRUE;
		}
	}
	MessageBox(NULL,"Can not create socket","Net Tic-Tac-Toe",MB_OK);
	return FALSE;
}

void CListenSocket::OnAccept(int nErrorCode)
{
	if (nErrorCode == 0)
	{
		m_pConnect->GoodAccept();
	}
	else
	{
		m_pConnect->BadAccept();
	}
}

/////////////////////////////////////////////////////////////////////////////
// CConnect dialog
void CConnect::GoodAccept()
{
	OnOK();
}

void CConnect::BadAccept()
{
	MessageBox("Error Occured During Connection","Net Tic-Tac-Toe");
	OnCancel();
}

CConnect::CConnect(CWnd* pParent /*=NULL*/)
	: CDialog(CConnect::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConnect)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CConnect::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConnect)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConnect, CDialog)
	//{{AFX_MSG_MAP(CConnect)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////
// CConnect message handlers

void CConnect::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

BOOL CConnect::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	if (!m_ListenSock.DidCreate(this))
	{
		OnCancel();
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
/////////////////////////////////////////////////////////////////////////////
// CFindHost dialog


CFindHost::CFindHost(CWnd* pParent /*=NULL*/)
	: CDialog(CFindHost::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFindHost)
	m_Address = _T("");
	m_Name = _T("");
	//}}AFX_DATA_INIT
}


void CFindHost::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFindHost)
	DDX_Text(pDX, IDC_ADDRESS, m_Address);
	DDX_Text(pDX, IDC_NAME, m_Name);
	//}}AFX_DATA_MAP
	if (pDX->m_bSaveAndValidate)
	{
		if ((m_Address.GetLength() < 1)||
			(m_Name.GetLength() < 1))
		{
			MessageBox("Fields can not be left blank!","Net Tic-Tac-Toe");
			pDX->Fail();
		}
	}
}


BEGIN_MESSAGE_MAP(CFindHost, CDialog)
	//{{AFX_MSG_MAP(CFindHost)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFindHost message handlers
