// nettttDlg.h : header file
//

////////////////////////
// CMyObjectSocket
class CMyObjectSocket: public CObjectSocket
{
public:
	CMyObjectSocket() : CObjectSocket() {}
	void OnForcedDrop();
};

/////////////////////////////////////////////////////////////////////////////
// CNettttDlg dialog

class CNettttDlg : public CDialog
{
// Construction
	friend class CTTTWnd;
	CMyObjectSocket m_ObjSocket;
	int m_nLineScroll;
	
public:
	CNettttDlg(CWnd* pParent = NULL);	// standard constructor
	CTTTWnd * pGame;
	CString m_LocalName;
	CString m_RemoteName;
	CString m_MsgBoard;

	void UpdateStatus();
	void CreateGameBoard();

// Dialog Data
	//{{AFX_DATA(CNettttDlg)
	enum { IDD = IDD_NETTTT_DIALOG };
	CEdit	m_Status;
	CButton	m_SendBut;
	CStatic	m_PicBoard;
	CEdit	m_NewMessage;
	CEdit	m_MessageBoard;
	CButton	m_HostBut;
	CButton	m_DropBut;
	CButton	m_ConnectBut;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CNettttDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CNettttDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnConnectbut();
	afx_msg void OnDropbut();
	afx_msg void OnHostbut();
	afx_msg void OnChangeNewmessage();
	afx_msg void OnSendbut();
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

extern CNettttDlg * pMainDlg;
/////////////////////////////////////////////////////////////////////////////
// CTTTWnd window
class CTurn;
class CTTTWnd : public CWnd
{
// Construction
	
public:	  
	CTurn * m_pTurn;
	CTTTWnd();
	void AddTurn(CTurn * pTurn);
	CRect GetBox(int space,CRect& r);
// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTTTWnd)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CTTTWnd();

	// Generated message map functions
protected:
	//{{AFX_MSG(CTTTWnd)
	afx_msg void OnPaint();
	afx_msg void OnDestroy();
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
