/****************************************************\
*
* IOCTL.H - Common include file for IRQHOOK.VXD and 
* the GUI
*
*\***************************************************/

/* Commands that the GUI can send the device driver */
enum {
 CMD_reset = 1,
 CMD_getstat,
 CMD_setirqs, 
 CMD_gettime,
 CMD_get_hookable_irq_bitmask
};
 
/* Data used for timestamp translation */
struct TIMESTAMP {
 DWORD Date; /* Placeholder for date (ignored, 
 but required by VTD API) */
 DWORD Time; /* Time since midnight in ms */
 DWORD HiWord; /* The number of real time clock 
 ticks that have elapsed */
 DWORD LoWord; /* since the current Windows 
 session was started. */
};

/* Size of a log buffer */
#define STORE_SIZE 8*1024 /* 8K Bytes */
#define STORE_SIZE_DWORDS STORE_SIZE/sizeof(DWORD) 
