// demodlg.cpp : implementation file
//

#include "stdafx.h"
#include "oncommex.h"
#include "demodlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg dialog


CDemoDlg::CDemoDlg(CWnd* pParent /*=NULL*/)
    : CDialog(CDemoDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CDemoDlg)
	m_strSelection = "";
	//}}AFX_DATA_INIT
}

void CDemoDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CDemoDlg)
	DDX_Text(pDX, IDC_SELECTION, m_strSelection);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemoDlg, CDialog)
    //{{AFX_MSG_MAP(CDemoDlg)
    ON_BN_CLICKED(IDC_SELECTION_LIST, OnSelectionList)  
    ON_COMMAND_EX(ID_POPUP_RECT, OnPopup)
    ON_COMMAND_EX(ID_POPUP_TRG, OnPopup)
    ON_COMMAND_EX(ID_POPUP_LINE, OnPopup)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CDemoDlg message handlers

void CDemoDlg::OnSelectionList()
{

    CMenu Menu;
    RECT rc;
    
    // Load Menu from Apps Resources
    
    Menu.LoadMenu( IDR_POPUP);

    CMenu *pPopup = Menu.GetSubMenu( 0);
    
    // Convert Mouse Point to Screen Coordinates ( as expected by TrackPopup)
    
    (( CWnd*) GetDlgItem( IDC_SELECTION_LIST))->GetWindowRect( &rc); 
    
    // Draw and Track the Floating Popup
    
    pPopup->TrackPopupMenu( TPM_LEFTALIGN | TPM_RIGHTBUTTON,
                                                  rc.right + 10, rc.top, this); 

    // Destroy Menu 
                                                  
    pPopup->DestroyMenu();
}

BOOL CDemoDlg::OnPopup( UINT nId)
{

    switch( nId)
    {
        case ID_POPUP_RECT: 
        
            SetDlgItemText( IDC_SELECTION, "Rectangle"); 
            break;
            
        case ID_POPUP_TRG:
        
            SetDlgItemText( IDC_SELECTION, "Triangle"); 
            break;
         
        case ID_POPUP_LINE: 
        
            SetDlgItemText( IDC_SELECTION, "Line");
            break;
    }
    
    return TRUE;
}
