//
// JUN98A.CPP
//
// This program demonstrates a problem with
// specific instantiation of template functions.
// Despite the fact that a specific version of
// Max() is being created, the program seems
// to only instantiate a single version.
//
// Compile this program using the following
// command line:
//
//  cl /GX Jun98a.cpp
//

#include <iostream>

using namespace std;

template < int A, int B >
int Max()
{
   return ( A > B ) ? A : B;
}

int main()
{
    cout << "Max<1, 10>() returns " << Max<1, 10>() << "\n";
    cout << "Max<3, 3>() returns  " << Max<3, 3>()  << "\n";
    cout << "Max<4, 3>() returns  " << Max<4, 3>()  << "\n";
    return 0;
}




